Ruby: ext/readline/readline.c File Reference

Ruby 3.0.5p211 (2022-11-24 revision ba5cf0f7c52d4d35cc6a173c89eda98ceffa2dcf)

Macros | Functions
readline.c File Reference
`#include "ruby/config.h"`
`#include <errno.h>`
`#include <stdio.h>`
`#include <string.h>`
`#include "ruby/io.h"`
`#include "ruby/thread.h"`

Go to the source code of this file.

## Macros
#define | EDIT_LINE_LIBRARY_VERSION "EditLine wrapper"
#define | USE_INSERT_IGNORE_ESCAPE 0
#define | COMPLETION_PROC "completion_proc"
#define | COMPLETION_CASE_FOLD "completion_case_fold"
#define | rl_filename_completion_function filename_completion_function
#define | rl_username_completion_function username_completion_function
#define | rl_completion_matches completion_matches
#define | OutputStringValue(str)
#define | readline_s_set_pre_input_hook rb_f_notimplement
#define | readline_s_get_pre_input_hook rb_f_notimplement
#define | readline_s_insert_text rb_f_notimplement
#define | readline_s_delete_text rb_f_notimplement
#define | readline_s_redisplay rb_f_notimplement
#define | readline_s_set_quoting_detection_proc rb_f_notimplement
#define | readline_s_get_quoting_detection_proc rb_f_notimplement
#define | readline_s_get_line_buffer rb_f_notimplement
#define | readline_s_get_point rb_f_notimplement
#define | readline_s_set_point rb_f_notimplement
#define | readline_s_set_screen_size rb_f_notimplement
#define | readline_s_get_screen_size rb_f_notimplement
#define | readline_s_vi_editing_mode rb_f_notimplement
#define | readline_s_vi_editing_mode_p rb_f_notimplement
#define | readline_s_emacs_editing_mode rb_f_notimplement
#define | readline_s_emacs_editing_mode_p rb_f_notimplement
#define | readline_s_set_completion_append_character rb_f_notimplement
#define | readline_s_get_completion_append_character rb_f_notimplement
#define | readline_s_get_completion_quote_character rb_f_notimplement
#define | readline_s_set_basic_word_break_characters rb_f_notimplement
#define | readline_s_get_basic_word_break_characters rb_f_notimplement
#define | readline_s_set_completer_word_break_characters rb_f_notimplement
#define | readline_s_get_completer_word_break_characters rb_f_notimplement
#define | readline_s_set_special_prefixes rb_f_notimplement
#define | readline_s_get_special_prefixes rb_f_notimplement
#define | readline_s_set_basic_quote_characters rb_f_notimplement
#define | readline_s_get_basic_quote_characters rb_f_notimplement
#define | readline_s_set_completer_quote_characters rb_f_notimplement
#define | readline_s_get_completer_quote_characters rb_f_notimplement
#define | readline_s_set_filename_quote_characters rb_f_notimplement
#define | readline_s_get_filename_quote_characters rb_f_notimplement
#define | readline_s_refresh_line rb_f_notimplement
#define | hist_set rb_f_notimplement
#define | hist_clear rb_f_notimplement

## Functions
void | Init_readline (void)

## Macro Definition Documentation

## ◆ COMPLETION_CASE_FOLD

#define COMPLETION_CASE_FOLD "completion_case_fold"

Definition at line 59 of file readline.c.

## ◆ COMPLETION_PROC

#define COMPLETION_PROC "completion_proc"

Definition at line 58 of file readline.c.

## ◆ EDIT_LINE_LIBRARY_VERSION

#define EDIT_LINE_LIBRARY_VERSION "EditLine wrapper"

Definition at line 49 of file readline.c.

## ◆ hist_clear

#define hist_clear rb_f_notimplement

Definition at line 1868 of file readline.c.

## ◆ hist_set

#define hist_set rb_f_notimplement

Definition at line 1751 of file readline.c.

## ◆ OutputStringValue

#define OutputStringValue | ( |  | str | ) |

Value:
do {\
StringValueCStr(str);\
(str) = rb_str_conv_enc((str), rb_enc_get(str), rb_locale_encoding());\
} while (0)\
rb_enc_get
rb_encoding * rb_enc_get(VALUE obj)
Definition: encoding.c:1070
rb_locale_encoding
rb_encoding * rb_locale_encoding(void)
Definition: encoding.c:1583
str
char str[HTML_ESCAPE_MAX_LEN+1]
Definition: escape.c:18
rb_str_conv_enc
VALUE rb_str_conv_enc(VALUE str, rb_encoding *from, rb_encoding *to)
Definition: string.c:1100

Definition at line 96 of file readline.c.

## ◆ readline_s_delete_text

#define readline_s_delete_text rb_f_notimplement

Definition at line 744 of file readline.c.

## ◆ readline_s_emacs_editing_mode

#define readline_s_emacs_editing_mode rb_f_notimplement

Definition at line 1207 of file readline.c.

## ◆ readline_s_emacs_editing_mode_p

#define readline_s_emacs_editing_mode_p rb_f_notimplement

Definition at line 1225 of file readline.c.

## ◆ readline_s_get_basic_quote_characters

#define readline_s_get_basic_quote_characters rb_f_notimplement

Definition at line 1561 of file readline.c.

## ◆ readline_s_get_basic_word_break_characters

#define readline_s_get_basic_word_break_characters rb_f_notimplement

Definition at line 1391 of file readline.c.

## ◆ readline_s_get_completer_quote_characters

#define readline_s_get_completer_quote_characters rb_f_notimplement

Definition at line 1617 of file readline.c.

## ◆ readline_s_get_completer_word_break_characters

#define readline_s_get_completer_word_break_characters rb_f_notimplement

Definition at line 1446 of file readline.c.

## ◆ readline_s_get_completion_append_character

#define readline_s_get_completion_append_character rb_f_notimplement

Definition at line 1307 of file readline.c.

## ◆ readline_s_get_completion_quote_character

#define readline_s_get_completion_quote_character rb_f_notimplement

Definition at line 1336 of file readline.c.

## ◆ readline_s_get_filename_quote_characters

#define readline_s_get_filename_quote_characters rb_f_notimplement

Definition at line 1671 of file readline.c.

## ◆ readline_s_get_line_buffer

#define readline_s_get_line_buffer rb_f_notimplement

Definition at line 955 of file readline.c.

## ◆ readline_s_get_point

#define readline_s_get_point rb_f_notimplement

Definition at line 998 of file readline.c.

## ◆ readline_s_get_pre_input_hook

#define readline_s_get_pre_input_hook rb_f_notimplement

Definition at line 666 of file readline.c.

## ◆ readline_s_get_quoting_detection_proc

#define readline_s_get_quoting_detection_proc rb_f_notimplement

Definition at line 898 of file readline.c.

## ◆ readline_s_get_screen_size

#define readline_s_get_screen_size rb_f_notimplement

Definition at line 1147 of file readline.c.

## ◆ readline_s_get_special_prefixes

#define readline_s_get_special_prefixes rb_f_notimplement

Definition at line 1508 of file readline.c.

## ◆ readline_s_insert_text

#define readline_s_insert_text rb_f_notimplement

Definition at line 688 of file readline.c.

## ◆ readline_s_redisplay

#define readline_s_redisplay rb_f_notimplement

Definition at line 766 of file readline.c.

## ◆ readline_s_refresh_line

#define readline_s_refresh_line rb_f_notimplement

Definition at line 1690 of file readline.c.

## ◆ readline_s_set_basic_quote_characters

#define readline_s_set_basic_quote_characters rb_f_notimplement

Definition at line 1541 of file readline.c.

## ◆ readline_s_set_basic_word_break_characters

#define readline_s_set_basic_word_break_characters rb_f_notimplement

Definition at line 1370 of file readline.c.

## ◆ readline_s_set_completer_quote_characters

#define readline_s_set_completer_quote_characters rb_f_notimplement

Definition at line 1596 of file readline.c.

## ◆ readline_s_set_completer_word_break_characters

#define readline_s_set_completer_word_break_characters rb_f_notimplement

Definition at line 1425 of file readline.c.

## ◆ readline_s_set_completion_append_character

#define readline_s_set_completion_append_character rb_f_notimplement

Definition at line 1282 of file readline.c.

## ◆ readline_s_set_filename_quote_characters

#define readline_s_set_filename_quote_characters rb_f_notimplement

Definition at line 1650 of file readline.c.

## ◆ readline_s_set_point

#define readline_s_set_point rb_f_notimplement

Definition at line 999 of file readline.c.

## ◆ readline_s_set_pre_input_hook

#define readline_s_set_pre_input_hook rb_f_notimplement

Definition at line 665 of file readline.c.

## ◆ readline_s_set_quoting_detection_proc

#define readline_s_set_quoting_detection_proc rb_f_notimplement

Definition at line 897 of file readline.c.

## ◆ readline_s_set_screen_size

#define readline_s_set_screen_size rb_f_notimplement

Definition at line 1120 of file readline.c.

## ◆ readline_s_set_special_prefixes

#define readline_s_set_special_prefixes rb_f_notimplement

Definition at line 1507 of file readline.c.

## ◆ readline_s_vi_editing_mode

#define readline_s_vi_editing_mode rb_f_notimplement

Definition at line 1168 of file readline.c.

## ◆ readline_s_vi_editing_mode_p

#define readline_s_vi_editing_mode_p rb_f_notimplement

Definition at line 1186 of file readline.c.

## ◆ rl_completion_matches

#define rl_completion_matches completion_matches

Definition at line 84 of file readline.c.

## ◆ rl_filename_completion_function

#define rl_filename_completion_function filename_completion_function

Definition at line 76 of file readline.c.

## ◆ rl_username_completion_function

#define rl_username_completion_function username_completion_function

Definition at line 79 of file readline.c.

## ◆ USE_INSERT_IGNORE_ESCAPE

#define USE_INSERT_IGNORE_ESCAPE 0

Definition at line 54 of file readline.c.

## Function Documentation

## ◆ Init_readline()

void Init_readline | ( | void |  | ) |

Definition at line 1927 of file readline.c.

References COMPLETION_CASE_FOLD, COMPLETION_PROC, EDIT_LINE_LIBRARY_VERSION, free, hist_clear, hist_set, id_call, NULL, rb_cObject, rb_define_const(), rb_define_module(), rb_define_module_function, rb_define_singleton_method, rb_extend_object(), rb_gc_register_address(), rb_intern(), rb_mEnumerable, rb_obj_alloc(), rb_str_new_cstr, readline_s_delete_text, readline_s_emacs_editing_mode, readline_s_emacs_editing_mode_p, readline_s_get_basic_quote_characters, readline_s_get_basic_word_break_characters, readline_s_get_completer_quote_characters, readline_s_get_completer_word_break_characters, readline_s_get_completion_append_character, readline_s_get_completion_quote_character, readline_s_get_filename_quote_characters, readline_s_get_line_buffer, readline_s_get_point, readline_s_get_pre_input_hook, readline_s_get_quoting_detection_proc, readline_s_get_screen_size, readline_s_get_special_prefixes, readline_s_insert_text, readline_s_redisplay, readline_s_refresh_line, readline_s_set_basic_quote_characters, readline_s_set_basic_word_break_characters, readline_s_set_completer_quote_characters, readline_s_set_completer_word_break_characters, readline_s_set_completion_append_character, readline_s_set_filename_quote_characters, readline_s_set_point, readline_s_set_pre_input_hook, readline_s_set_quoting_detection_proc, readline_s_set_screen_size, readline_s_set_special_prefixes, readline_s_vi_editing_mode, readline_s_vi_editing_mode_p, and strlen().